* CHSWAP
*
* pjwitte 2o24+
* All code is my own work except as and where stated
*
* V0.02, pjw, 2024 Feb 05, hard float (saving 22b)
*
* Compatible with all systems (presumably)
*


        section code

        xdef CHSWAP

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

*
CHSWAP
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Swap two S*BASIC channels around
*
* er = CHSWAP(#ch1, #ch2)
*
* er is ok, NO, or hard BP
*
* Whatever device ch1 was pointing to is now pointing to the device ch2 was
* pointing to and vice versa. If ch1 = ch2 then nothing happens..
*
* Could be dangerous in some situations!
*
        lea.l 16(a3),a4         check for exactly 2 parameters
        cmpa.l a4,a5
        bne.s err_bp

        btst #7,1(a6,a3.l)      has the first parameter a hash?
        beq.s err_bp             no, so error

        btst #7,9(a6,a3.l)      has the second parameter a hash?
        beq.s err_bp             no, so error

        move.w sb.gtint,a2      get some integers
        jsr (a2)
        bne.s err                not integers

        move.w 0(a6,a1.l),d6    get first channel number
        move.w 2(a6,a1.l),d4    get second channel number

        moveq #2,d1             make a wee bit more room
        move.w qa.resri,a2
        jsr (a2)

        subq.l #2,sb_arthp(a6)  float return needs 6b (4 + 2)
        move.l sb_arthp(a6),a1  RI stack pointer
        clr.l 2(a6,a1.l)        zero mantissa in part-preparation

*                               process first channel number
        bsr.s chan_get          get ID in d0, a6+d6 -> slot

        move.l d6,d5            save details
        move.l d0,d1

        move.w d4,d6            process second channel number
        bsr.s chan_get          get ID in d0, a6+d6 -> slot

        move.l d1,(a6,d6.l)     swap!
        move.l d0,(a6,d5.l)

        clr.w (a6,a1.l)         zero
        bra.s ret

err_bp
        moveq #err.ipar,d0

err
        rts

*
chan_get
        mulu    #ch.len,d6      make d6 (long) pointer to channel table
        add.l   sb_chanb(a6),d6 bv.chbas
        cmp.l   sb_chanp(a6),d6 bv.chp is it within the table?
        bge.s   cherr_no        ... no

        move.l  0(a6,d6.l),d0   channel id
        bmi.s   cherr_no        whoops! Not open

chan_exit
        rts

cherr_no
        addq.l #4,sp            dont go back
        move.w #$0803,(a6,a1.l) channel not open
        move.b #$a0,2(a6,a1.l)  $0803 A0000000 = -6 = err.ichn

ret
        moveq #ar.float,d4      return float
        moveq #0,d0
        rts

*
        end
